Index: drivers/pcmcia/cs.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/pcmcia/cs.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/pcmcia/cs.c	22 Jul 2004 19:50:25 -0000	1.1
+++ drivers/pcmcia/cs.c	4 Aug 2004 01:29:27 -0000	1.2
@@ -3,7 +3,7 @@
     Kernel Card Services -- core services
 
     cs.c 1.271 2000/10/02 20:27:49
-    
+
     The contents of this file are subject to the Mozilla Public
     License Version 1.1 (the "License"); you may not use this file
     except in compliance with the License. You may obtain a copy of
@@ -28,7 +28,7 @@
     and other provisions required by the GPL.  If you do not delete
     the provisions above, a recipient may use your version of this
     file under either the MPL or the GPL.
-    
+
 ======================================================================*/
 
 #include <linux/module.h>
@@ -92,7 +92,7 @@
 MODULE_AUTHOR("David Hinds <dahinds@users.sourceforge.net>");
 MODULE_DESCRIPTION("Linux Kernel Card Services " CS_RELEASE
 		   "\n  options:" OPTIONS);
-MODULE_LICENSE("Dual MPL/GPL");	  
+MODULE_LICENSE("Dual MPL/GPL");
 
 #define INT_MODULE_PARM(n, v) static int n = v; MODULE_PARM(n, "i")
 
@@ -123,7 +123,7 @@
 static const char *version =
 "cs.c 1.279 2001/10/13 00:08:28 (David Hinds)";
 #endif
- 
+
 /*====================================================================*/
 
 socket_state_t dead_socket = {
@@ -299,7 +299,7 @@
 
     Low-level PC Card interface drivers need to register with Card
     Services using these calls.
-    
+
 ======================================================================*/
 
 static int setup_socket(socket_info_t *);
@@ -331,7 +331,7 @@
     s->use_bus_pm = use_bus_pm;
     s->erase_busy.next = s->erase_busy.prev = &s->erase_busy;
     spin_lock_init(&s->lock);
-    
+
     for (i = 0; i < sockets; i++)
 	if (socket_table[i] == NULL) break;
     socket_table[i] = s;
@@ -365,7 +365,7 @@
     for (ns = 0; ns < nsock; ns++) {
 	pcmcia_register_socket (ns, ss_entry, 0);
     }
-    
+
     return 0;
 } /* register_ss_entry */
 
@@ -457,7 +457,7 @@
 static void shutdown_socket(socket_info_t *s)
 {
     client_t **c;
-    
+
     DEBUG(1, "cs: shutdown_socket(%p)\n", s);
 
     /* Blank out the socket state */
@@ -561,7 +561,7 @@
     have several causes: card insertion, a call to reset_socket, or
     recovery from a suspend/resume cycle.  Unreset_socket() sends
     a CS event that matches the cause of the reset.
-    
+
 ======================================================================*/
 
 static void reset_socket(socket_info_t *s)
@@ -616,7 +616,7 @@
 	    s->state &= ~SOCKET_SETUP_PENDING;
 	} else {
 	    send_event(s, CS_EVENT_CARD_RESET, CS_EVENT_PRI_LOW);
-	    if (s->reset_handle) { 
+	    if (s->reset_handle) {
 		    s->reset_handle->event_callback_args.info = NULL;
 		    EVENT(s->reset_handle, CS_EVENT_RESET_COMPLETE,
 			  CS_EVENT_PRI_LOW);
@@ -631,7 +631,7 @@
     valid clients.  Parse_events() interprets the event bits from
     a card status change report.  Do_shutdown() handles the high
     priority stuff associated with a card removal.
-    
+
 ======================================================================*/
 
 static int send_event(socket_info_t *s, event_t event, int priority)
@@ -641,7 +641,7 @@
     DEBUG(1, "cs: send_event(sock %d, event %d, pri %d)\n",
 	  s->sock, event, priority);
     ret = 0;
-    for (; client; client = client->next) { 
+    for (; client; client = client->next) {
 	if (client->state & (CLIENT_UNBOUND|CLIENT_STALE))
 	    continue;
 	if (client->EventMask & event) {
@@ -723,7 +723,7 @@
 
     This does not comply with the latest PC Card spec for handling
     power management events.
-    
+
 ======================================================================*/
 
 void pcmcia_suspend_socket (socket_info_t *s)
@@ -780,7 +780,7 @@
 /*======================================================================
 
     Special stuff for managing IO windows, because they are scarce.
-    
+
 ======================================================================*/
 
 static int alloc_io_space(socket_info_t *s, u_int attr, ioaddr_t *base,
@@ -869,7 +869,7 @@
     Access_configuration_register() reads and writes configuration
     registers in attribute memory.  Memory window 0 is reserved for
     this and the tuple reading services.
-    
+
 ======================================================================*/
 
 int pcmcia_access_configuration_register(client_handle_t handle,
@@ -879,7 +879,7 @@
     config_t *c;
     int addr;
     u_char val;
-    
+
     if (CHECK_HANDLE(handle))
 	return CS_BAD_HANDLE;
     s = SOCKET(handle);
@@ -897,7 +897,7 @@
 	return CS_CONFIGURATION_LOCKED;
 
     addr = (c->ConfigBase + reg->Offset) >> 1;
-    
+
     switch (reg->Action) {
     case CS_READ:
 	read_cis_mem(s, 1, addr, 1, &val);
@@ -920,7 +920,7 @@
     It is normally called by Driver Services after it has identified
     a newly inserted card.  An instance of that driver will then be
     eligible to register as a client of this socket.
-    
+
 ======================================================================*/
 
 int pcmcia_bind_device(bind_req_t *req)
@@ -956,23 +956,23 @@
     region.  It is normally called by Driver Services after it has
     identified a memory device type.  An instance of the corresponding
     driver will then be able to register to control this region.
-    
+
 ======================================================================*/
 
 int pcmcia_bind_mtd(mtd_bind_t *req)
 {
     socket_info_t *s;
     memory_handle_t region;
-    
+
     if (CHECK_SOCKET(req->Socket))
 	return CS_BAD_SOCKET;
     s = SOCKET(req);
-    
+
     if (req->Attributes & REGION_TYPE_AM)
 	region = s->a_region;
     else
 	region = s->c_region;
-    
+
     while (region) {
 	if (region->info.CardOffset == req->CardOffset) break;
 	region = region->info.next;
@@ -980,7 +980,7 @@
     if (!region || (region->mtd != NULL))
 	return CS_BAD_OFFSET;
     strncpy(region->dev_info, (char *)req->dev_info, DEV_NAME_LEN);
-    
+
     DEBUG(1, "cs: bind_mtd(): attr 0x%x, offset 0x%x, dev %s\n",
 	  req->Attributes, req->CardOffset, (char *)req->dev_info);
     return CS_SUCCESS;
@@ -995,7 +995,7 @@
     memory_handle_t region;
     u_long flags;
     int i, sn;
-    
+
     DEBUG(1, "cs: deregister_client(%p)\n", handle);
     if (CHECK_HANDLE(handle))
 	return CS_BAD_HANDLE;
@@ -1014,7 +1014,7 @@
 	for (region = s->c_region; region; region = region->info.next)
 	    if (region->mtd == handle) region->mtd = NULL;
     }
-    
+
     sn = handle->Socket; s = socket_table[sn];
 
     if ((handle->state & CLIENT_STALE) ||
@@ -1039,7 +1039,7 @@
 
     if (--s->real_clients == 0)
         register_callback(s, NULL, NULL);
-    
+
     return CS_SUCCESS;
 } /* deregister_client */
 
@@ -1050,7 +1050,7 @@
 {
     socket_info_t *s;
     config_t *c;
-    
+
     if (CHECK_HANDLE(handle))
 	return CS_BAD_HANDLE;
     s = SOCKET(handle);
@@ -1062,7 +1062,7 @@
 	    return CS_BAD_ARGS;
     } else
 	config->Function = handle->Function;
-    
+
 #ifdef CONFIG_CARDBUS
     if (s->state & SOCKET_CARDBUS) {
 	u_char fn = config->Function;
@@ -1083,16 +1083,16 @@
 	return CS_SUCCESS;
     }
 #endif
-    
+
     c = (s->config != NULL) ? &s->config[config->Function] : NULL;
-    
+
     if ((c == NULL) || !(c->state & CONFIG_LOCKED)) {
 	config->Attributes = 0;
 	config->Vcc = s->socket.Vcc;
 	config->Vpp1 = config->Vpp2 = s->socket.Vpp;
 	return CS_SUCCESS;
     }
-    
+
     /* !!! This is a hack !!! */
     memcpy(&config->Attributes, &c->Attributes, sizeof(config_t));
     config->Attributes |= CONF_VALID_CLIENT;
@@ -1106,14 +1106,14 @@
     config->NumPorts2 = c->io.NumPorts2;
     config->Attributes2 = c->io.Attributes2;
     config->IOAddrLines = c->io.IOAddrLines;
-    
+
     return CS_SUCCESS;
 } /* get_configuration_info */
 
 /*======================================================================
 
     Return information about this version of Card Services.
-    
+
 ======================================================================*/
 
 int pcmcia_get_card_services_info(servinfo_t *info)
@@ -1131,7 +1131,7 @@
 
     Note that get_first_client() *does* recognize the Socket field
     in the request structure.
-    
+
 ======================================================================*/
 
 int pcmcia_get_first_client(client_handle_t *handle, client_req_t *req)
@@ -1246,7 +1246,7 @@
 
     Get the current socket state bits.  We don't support the latched
     SocketState yet: I haven't seen any point for it.
-    
+
 ======================================================================*/
 
 int pcmcia_get_status(client_handle_t handle, cs_status_t *status)
@@ -1254,7 +1254,7 @@
     socket_info_t *s;
     config_t *c;
     int val;
-    
+
     if (CHECK_HANDLE(handle))
 	return CS_BAD_HANDLE;
     s = SOCKET(handle);
@@ -1270,7 +1270,7 @@
 	return CS_NO_CARD;
     if (s->state & SOCKET_SETUP_PENDING)
 	status->CardState |= CS_EVENT_CARD_INSERTION;
-    
+
     /* Get info from the PRR, if necessary */
     if (handle->Function == BIND_FN_ALL) {
 	if (status->Function && (status->Function >= s->functions))
@@ -1316,7 +1316,7 @@
 /*======================================================================
 
     Change the card address of an already open memory window.
-    
+
 ======================================================================*/
 
 int pcmcia_get_mem_page(window_handle_t win, memreq_t *req)
@@ -1345,7 +1345,7 @@
 /*======================================================================
 
     Modify a locked socket configuration
-    
+
 ======================================================================*/
 
 int pcmcia_modify_configuration(client_handle_t handle,
@@ -1353,7 +1353,7 @@
 {
     socket_info_t *s;
     config_t *c;
-    
+
     if (CHECK_HANDLE(handle))
 	return CS_BAD_HANDLE;
     s = SOCKET(handle); c = CONFIG(handle);
@@ -1361,7 +1361,7 @@
 	return CS_NO_CARD;
     if (!(c->state & CONFIG_LOCKED))
 	return CS_CONFIGURATION_LOCKED;
-    
+
     if (mod->Attributes & CONF_IRQ_CHANGE_VALID) {
 	if (mod->Attributes & CONF_ENABLE_IRQ) {
 	    c->Attributes |= CONF_ENABLE_IRQ;
@@ -1413,7 +1413,7 @@
 	win->ctl.flags |= MAP_USE_WAIT;
     win->ctl.speed = req->AccessSpeed;
     set_mem_map(win->sock, &win->ctl);
-    
+
     return CS_SUCCESS;
 } /* modify_window */
 
@@ -1423,7 +1423,7 @@
     caller with a socket.  The driver must have already been bound
     to a socket with bind_device() -- in fact, bind_device()
     allocates the client structure that will be used.
-    
+
 ======================================================================*/
 
 int pcmcia_register_client(client_handle_t *handle, client_reg_t *req)
@@ -1431,7 +1431,7 @@
     client_t *client;
     socket_info_t *s;
     socket_t ns;
-    
+
     /* Look for unbound client with matching dev_info */
     client = NULL;
     for (ns = 0; ns < sockets; ns++) {
@@ -1471,7 +1471,7 @@
 
     if (s->state & SOCKET_CARDBUS)
 	client->state |= CLIENT_CARDBUS;
-    
+
     if ((!(s->state & SOCKET_CARDBUS)) && (s->functions == 0) &&
 	(client->Function != BIND_FN_ALL)) {
 	cistpl_longlink_mfc_t mfc;
@@ -1486,7 +1486,7 @@
 		return CS_OUT_OF_RESOURCE;
 	memset(s->config, 0, sizeof(config_t) * s->functions);
     }
-    
+
     DEBUG(1, "cs: register_client(): client 0x%p, sock %d, dev %s\n",
 	  client, client->Socket, client->dev_info);
     if (client->EventMask & CS_EVENT_REGISTRATION_COMPLETE)
@@ -1508,13 +1508,13 @@
     pccard_io_map io = { 0, 0, 0, 0, 1 };
     socket_info_t *s;
     int i;
-    
+
     if (CHECK_HANDLE(handle) ||
 	!(handle->state & CLIENT_CONFIG_LOCKED))
 	return CS_BAD_HANDLE;
     handle->state &= ~CLIENT_CONFIG_LOCKED;
     s = SOCKET(handle);
-    
+
 #ifdef CONFIG_CARDBUS
     if (handle->state & CLIENT_CARDBUS) {
 	cb_disable(s);
@@ -1522,7 +1522,7 @@
 	return CS_SUCCESS;
     }
 #endif
-    
+
     if (!(handle->state & CLIENT_STALE)) {
 	config_t *c = CONFIG(handle);
 	if (--(s->lock_count) == 0) {
@@ -1543,7 +1543,7 @@
 	    }
 	c->state &= ~CONFIG_LOCKED;
     }
-    
+
     return CS_SUCCESS;
 } /* release_configuration */
 
@@ -1554,25 +1554,25 @@
     the actual socket configuration, so if the client is "stale", we
     don't bother checking the port ranges against the current socket
     values.
-    
+
 ======================================================================*/
 
 int pcmcia_release_io(client_handle_t handle, io_req_t *req)
 {
     socket_info_t *s;
-    
+
     if (CHECK_HANDLE(handle) || !(handle->state & CLIENT_IO_REQ))
 	return CS_BAD_HANDLE;
     handle->state &= ~CLIENT_IO_REQ;
     s = SOCKET(handle);
-    
+
 #ifdef CONFIG_CARDBUS
     if (handle->state & CLIENT_CARDBUS) {
 	cb_release(s);
 	return CS_SUCCESS;
     }
 #endif
-    
+
     if (!(handle->state & CLIENT_STALE)) {
 	config_t *c = CONFIG(handle);
 	if (c->state & CONFIG_LOCKED)
@@ -1588,7 +1588,7 @@
     release_io_space(s, req->BasePort1, req->NumPorts1);
     if (req->NumPorts2)
 	release_io_space(s, req->BasePort2, req->NumPorts2);
-    
+
     return CS_SUCCESS;
 } /* release_io */
 
@@ -1601,7 +1601,7 @@
 	return CS_BAD_HANDLE;
     handle->state &= ~CLIENT_IRQ_REQ;
     s = SOCKET(handle);
-    
+
     if (!(handle->state & CLIENT_STALE)) {
 	config_t *c = CONFIG(handle);
 	if (c->state & CONFIG_LOCKED)
@@ -1615,7 +1615,7 @@
 	    s->irq.AssignedIRQ = 0;
 	}
     }
-    
+
     if (req->Attributes & IRQ_HANDLE_PRESENT) {
 	bus_free_irq(s->cap.bus, req->AssignedIRQ, req->Instance);
     }
@@ -1624,7 +1624,7 @@
     if (req->AssignedIRQ != s->cap.pci_irq)
 	undo_irq(req->Attributes, req->AssignedIRQ);
 #endif
-    
+
     return CS_SUCCESS;
 } /* cs_release_irq */
 
@@ -1633,7 +1633,7 @@
 int pcmcia_release_window(window_handle_t win)
 {
     socket_info_t *s;
-    
+
     if ((win == NULL) || (win->magic != WINDOW_MAGIC))
 	return CS_BAD_HANDLE;
     s = win->sock;
@@ -1651,7 +1651,7 @@
     win->handle->state &= ~CLIENT_WIN_REQ(win->index);
 
     win->magic = 0;
-    
+
     return CS_SUCCESS;
 } /* release_window */
 
@@ -1665,13 +1665,13 @@
     socket_info_t *s;
     config_t *c;
     pccard_io_map iomap;
-    
+
     if (CHECK_HANDLE(handle))
 	return CS_BAD_HANDLE;
     i = handle->Socket; s = socket_table[i];
     if (!(s->state & SOCKET_PRESENT))
 	return CS_NO_CARD;
-    
+
 #ifdef CONFIG_CARDBUS
     if (handle->state & CLIENT_CARDBUS) {
 	if (!(req->IntType & INT_CARDBUS))
@@ -1684,7 +1684,7 @@
 	return CS_SUCCESS;
     }
 #endif
-    
+
     if (req->IntType & INT_CARDBUS)
 	return CS_UNSUPPORTED_MODE;
     c = CONFIG(handle);
@@ -1699,9 +1699,9 @@
     s->socket.Vpp = req->Vpp1;
     if (set_socket(s, &s->socket))
 	return CS_BAD_VPP;
-    
+
     c->Vcc = req->Vcc; c->Vpp1 = c->Vpp2 = req->Vpp1;
-    
+
     /* Pick memory or I/O card, DMA mode, interrupt */
     c->IntType = req->IntType;
     c->Attributes = req->Attributes;
@@ -1719,7 +1719,7 @@
 	s->socket.io_irq = 0;
     set_socket(s, &s->socket);
     s->lock_count++;
-    
+
     /* Set up CIS configuration registers */
     base = c->ConfigBase = req->ConfigBase;
     c->Present = c->CardValues = req->Present;
@@ -1764,7 +1764,7 @@
 	u_char b = c->io.NumPorts1 + c->io.NumPorts2 - 1;
 	write_cis_mem(s, 1, (base + CISREG_IOSIZE)>>1, 1, &b);
     }
-    
+
     /* Configure I/O windows */
     if (c->state & CONFIG_IO_REQ) {
 	iomap.speed = io_speed;
@@ -1786,24 +1786,24 @@
 		s->io[i].Config++;
 	    }
     }
-    
+
     c->state |= CONFIG_LOCKED;
     handle->state |= CLIENT_CONFIG_LOCKED;
     return CS_SUCCESS;
 } /* request_configuration */
 
 /*======================================================================
-  
+
     Request_io() reserves ranges of port addresses for a socket.
     I have not implemented range sharing or alias addressing.
-    
+
 ======================================================================*/
 
 int pcmcia_request_io(client_handle_t handle, io_req_t *req)
 {
     socket_info_t *s;
     config_t *c;
-    
+
     if (CHECK_HANDLE(handle))
 	return CS_BAD_HANDLE;
     s = SOCKET(handle);
@@ -1862,15 +1862,15 @@
     hooked, we don't guarantee that an irq will still be available
     when the configuration is locked.  Now that I think about it,
     there might be a way to fix this using a dummy handler.
-    
+
 ======================================================================*/
 
 int pcmcia_request_irq(client_handle_t handle, irq_req_t *req)
 {
     socket_info_t *s;
     config_t *c;
-    int ret = 0, irq = 0;
-    
+    int ret = CS_IN_USE, irq = 0;
+
     if (CHECK_HANDLE(handle))
 	return CS_BAD_HANDLE;
     s = SOCKET(handle);
@@ -1881,13 +1881,9 @@
 	return CS_CONFIGURATION_LOCKED;
     if (c->state & CONFIG_IRQ_REQ)
 	return CS_IN_USE;
-    
-    /* Short cut: if there are no ISA interrupts, then it is PCI */
-    if (!s->cap.irq_mask) {
-	irq = s->cap.pci_irq;
-	ret = (irq) ? 0 : CS_IN_USE;
+
 #ifdef CONFIG_PCMCIA_PROBE
-    } else if (s->irq.AssignedIRQ != 0) {
+    if (s->irq.AssignedIRQ != 0) {
 	/* If the interrupt is already assigned, it must match */
 	irq = s->irq.AssignedIRQ;
 	if (req->IRQInfo1 & IRQ_INFO2_VALID) {
@@ -1896,7 +1892,6 @@
 	} else
 	    ret = ((req->IRQInfo1&IRQ_MASK) == irq) ? 0 : CS_BAD_ARGS;
     } else {
-	ret = CS_IN_USE;
 	if (req->IRQInfo1 & IRQ_INFO2_VALID) {
 	    u_int try, mask = req->IRQInfo2 & s->cap.irq_mask;
 	    for (try = 0; try < 2; try++) {
@@ -1911,13 +1906,17 @@
 	    irq = req->IRQInfo1 & IRQ_MASK;
 	    ret = try_irq(req->Attributes, irq, 1);
 	}
+    }
 #endif
+    if (ret != 0) {
+	if (!s->cap.pci_irq)
+	    return ret;
+	irq = s->cap.pci_irq;
     }
-    if (ret != 0) return ret;
 
     if (req->Attributes & IRQ_HANDLE_PRESENT) {
 	if (bus_request_irq(s->cap.bus, irq, req->Handler,
-			    ((req->Attributes & IRQ_TYPE_DYNAMIC_SHARING) || 
+			    ((req->Attributes & IRQ_TYPE_DYNAMIC_SHARING) ||
 			     (s->functions > 1) ||
 			     (irq == s->cap.pci_irq)) ? SA_SHIRQ : 0,
 			    handle->dev_info, req->Instance))
@@ -1927,7 +1926,7 @@
     c->irq.Attributes = req->Attributes;
     s->irq.AssignedIRQ = req->AssignedIRQ = irq;
     s->irq.Config++;
-    
+
     c->state |= CONFIG_IRQ_REQ;
     handle->state |= CLIENT_IRQ_REQ;
     return CS_SUCCESS;
@@ -1946,7 +1945,7 @@
     window_t *win;
     u_long align;
     int w;
-    
+
     if (CHECK_HANDLE(*handle))
 	return CS_BAD_HANDLE;
     s = SOCKET(*handle);
@@ -2013,7 +2012,7 @@
     /* Return window handle */
     req->Base = win->ctl.sys_start;
     *wh = win;
-    
+
     return CS_SUCCESS;
 } /* request_window */
 
@@ -2022,14 +2021,14 @@
     I'm not sure which "reset" function this is supposed to use,
     but for now, it uses the low-level interface's reset, not the
     CIS register.
-    
+
 ======================================================================*/
 
 int pcmcia_reset_card(client_handle_t handle, client_req_t *req)
 {
     int i, ret;
     socket_info_t *s;
-    
+
     if (CHECK_HANDLE(handle))
 	return CS_BAD_HANDLE;
     i = handle->Socket; s = socket_table[i];
@@ -2057,14 +2056,14 @@
 
     These shut down or wake up a socket.  They are sort of user
     initiated versions of the APM suspend and resume actions.
-    
+
 ======================================================================*/
 
 int pcmcia_suspend_card(client_handle_t handle, client_req_t *req)
 {
     int i;
     socket_info_t *s;
-    
+
     if (CHECK_HANDLE(handle))
 	return CS_BAD_HANDLE;
     i = handle->Socket; s = socket_table[i];
@@ -2085,7 +2084,7 @@
 {
     int i;
     socket_info_t *s;
-    
+
     if (CHECK_HANDLE(handle))
 	return CS_BAD_HANDLE;
     i = handle->Socket; s = socket_table[i];
@@ -2103,7 +2102,7 @@
 /*======================================================================
 
     These handle user requests to eject or insert a card.
-    
+
 ======================================================================*/
 
 int pcmcia_eject_card(client_handle_t handle, client_req_t *req)
@@ -2111,7 +2110,7 @@
     int i, ret;
     socket_info_t *s;
     u_long flags;
-    
+
     if (CHECK_HANDLE(handle))
 	return CS_BAD_HANDLE;
     i = handle->Socket; s = socket_table[i];
@@ -2127,9 +2126,9 @@
     spin_lock_irqsave(&s->lock, flags);
     do_shutdown(s);
     spin_unlock_irqrestore(&s->lock, flags);
-    
+
     return CS_SUCCESS;
-    
+
 } /* eject_card */
 
 int pcmcia_insert_card(client_handle_t handle, client_req_t *req)
@@ -2137,7 +2136,7 @@
     int i, status;
     socket_info_t *s;
     u_long flags;
-    
+
     if (CHECK_HANDLE(handle))
 	return CS_BAD_HANDLE;
     i = handle->Socket; s = socket_table[i];
@@ -2165,7 +2164,7 @@
 
     Maybe this should send a CS_EVENT_CARD_INSERTION event if we
     haven't sent one to this client yet?
-    
+
 ======================================================================*/
 
 int pcmcia_set_event_mask(client_handle_t handle, eventmask_t *mask)
@@ -2197,7 +2196,7 @@
 	printk(KERN_NOTICE);
     else
 	printk(KERN_NOTICE "%s: ", handle->dev_info);
-    
+
     for (i = 0; i < SERVICE_COUNT; i++)
 	if (service_table[i].key == err->func) break;
     if (i < SERVICE_COUNT)
@@ -2355,13 +2354,13 @@
     default:
 	return CS_UNSUPPORTED_FUNCTION; break;
     }
-    
+
 } /* CardServices */
 
 /*======================================================================
 
     OS-specific module glue goes here
-    
+
 ======================================================================*/
 /* in alpha order */
 EXPORT_SYMBOL(pcmcia_access_configuration_register);
@@ -2458,4 +2457,3 @@
 module_exit(exit_pcmcia_cs);
 
 /*====================================================================*/
-
Index: drivers/pcmcia/hd64465_ss.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/pcmcia/hd64465_ss.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/pcmcia/hd64465_ss.c	22 Jul 2004 19:50:26 -0000	1.1
+++ drivers/pcmcia/hd64465_ss.c	4 Aug 2004 01:29:27 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: hd64465_ss.c,v 1.1 2004/07/22 19:50:26 joff Exp $
+ * $Id: hd64465_ss.c,v 1.2 2004/08/04 01:29:27 joff Exp $
  *
  * Device driver for the PCMCIA controller module of the
  * Hitachi HD64465 handheld companion chip.
Index: drivers/pcmcia/i82092.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/pcmcia/i82092.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/pcmcia/i82092.c	22 Jul 2004 19:50:25 -0000	1.1
+++ drivers/pcmcia/i82092.c	4 Aug 2004 01:29:27 -0000	1.2
@@ -6,7 +6,7 @@
  * Author: Arjan Van De Ven <arjanv@redhat.com> 
  * Loosely based on i82365.c from the pcmcia-cs package
  *
- * $Id: i82092.c,v 1.1 2004/07/22 19:50:25 joff Exp $
+ * $Id: i82092.c,v 1.2 2004/08/04 01:29:27 joff Exp $
  */
 
 #include <linux/kernel.h>
@@ -14,6 +14,8 @@
 #include <linux/module.h>
 #include <linux/pci.h>
 #include <linux/init.h>
+#include <linux/sched.h>
+#include <linux/tqueue.h>
 
 #include <pcmcia/cs_types.h>
 #include <pcmcia/ss.h>
Index: drivers/pcmcia/i82092aa.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/pcmcia/i82092aa.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/pcmcia/i82092aa.h	22 Jul 2004 19:50:25 -0000	1.1
+++ drivers/pcmcia/i82092aa.h	4 Aug 2004 01:29:27 -0000	1.2
@@ -1,7 +1,7 @@
 #ifndef _INCLUDE_GUARD_i82092aa_H_
 #define _INCLUDE_GUARD_i82092aa_H_
 
-/* $Id: i82092aa.h,v 1.1 2004/07/22 19:50:25 joff Exp $ */
+/* $Id: i82092aa.h,v 1.2 2004/08/04 01:29:27 joff Exp $ */
 
 /* Debuging defines */
 #ifdef NOTRACE
